var isAndroid = navigator.userAgent.indexOf("Android") > -1 || navigator.userAgent.indexOf("Adr") > -1;
if (isAndroid && !window.appcore) {

    var messageQuery = [];
    var uniqueId = 1;

    function requestNative(plugName, nativeFun, data, responseCallback) {

        var message = {};
        message.plugName = plugName;
        message.data = data;
        var callbackId = "cb_" + uniqueId+++"_" + new Date().getTime();
        message.callbackId = callbackId;
        message.responseCallback = responseCallback;
        messageQuery.push({
            'callbackId': callbackId,
            'message': message
        });
        window.pnativejs.exec(plugName, nativeFun, JSON.stringify(message));

        return message;

    }

    function _handleMessageFromNative(messageJson) {

        setTimeout(function() {

            var nativeMessage = JSON.parse(messageJson);
            var message;
            if (nativeMessage.callbackId) {
                message = getObjByID(messageQuery, nativeMessage.callbackId).message;
                if (!message || !message.responseCallback) {
                    return;
                }
                message.responseCallback(nativeMessage.responseData);
                messageQuery.splice(getIndexByID(messageQuery, nativeMessage.callbackId), 1);
            }
        },
        0);
    }

    var plus = {
        requestNative: requestNative,
        _handleMessageFromNative: _handleMessageFromNative
    };

    window.appcore = plus;

}

function getObjByID(arr, callbackId) {

    var obj = {};
    for (var i = 0; i < arr.length; i++) {
        if (arr[i].callbackId == callbackId) {
            obj = arr[i]
            break;
        }
    }

    return obj;

}

function getIndexByID(arr, callbackId) {

    var index = 0;

    for (var i = 0; i < arr.length; i++) {
        if (arr[i].callbackId == callbackId) {
            index = i;
            break;
        }
    }

    return index;

}

function initAppCore() {

    var readyEvent = document.createEvent('Events');
    readyEvent.initEvent('appcoreready');
    document.dispatchEvent(readyEvent);

}